Wormholes(题意抽象+SPFA判负权环)

来源:互联网 发布:亿展网络 编辑:程序博客网 时间:2024/05/21 07:05


Link:http://poj.org/problem?id=3259


Wormholes
Time Limit: 2000MS Memory Limit: 65536KTotal Submissions: 36128 Accepted: 13198

Description

While exploring his many farms, Farmer John has discovered a number of amazing wormholes. A wormhole is very peculiar because it is a one-way path that delivers you to its destination at a time that is BEFORE you entered the wormhole! Each of FJ's farms comprises N (1 ≤ N ≤ 500) fields conveniently numbered 1..NM (1 ≤ M ≤ 2500) paths, and W (1 ≤ W ≤ 200) wormholes.

As FJ is an avid time-traveling fan, he wants to do the following: start at some field, travel through some paths and wormholes, and return to the starting field a time before his initial departure. Perhaps he will be able to meet himself :) .

To help FJ find out whether this is possible or not, he will supply you with complete maps to F (1 ≤ F ≤ 5) of his farms. No paths will take longer than 10,000 seconds to travel and no wormhole can bring FJ back in time by more than 10,000 seconds.

Input

Line 1: A single integer, FF farm descriptions follow. 
Line 1 of each farm: Three space-separated integers respectively: NM, and W 
Lines 2..M+1 of each farm: Three space-separated numbers (SET) that describe, respectively: a bidirectional path between S and E that requires T seconds to traverse. Two fields might be connected by more than one path. 
Lines M+2..M+W+1 of each farm: Three space-separated numbers (SET) that describe, respectively: A one way path from S to E that also moves the traveler back T seconds.

Output

Lines 1..F: For each farm, output "YES" if FJ can achieve his goal, otherwise output "NO" (do not include the quotes).

Sample Input

23 3 11 2 21 3 42 3 13 1 33 2 11 2 32 3 43 1 8

Sample Output

NOYES

Hint

For farm 1, FJ cannot travel back in time. 
For farm 2, FJ could travel back in time by the cycle 1->2->3->1, arriving back at his starting location 1 second before he leaves. He could start from anywhere on the cycle to accomplish this.

Source

USACO 2006 December Gold

解题思想:这题主要要理解当花费的时间为负时,说明能在起点看到原来的自己。由题意可抽象出判断给出的图中是否存在负权环,存在则输出“YES”,否则输出“NO”。输入的路的边权为正,虫洞的边权为负,而SPFA算法思想在求最短路时,只有负权环对其有影响,也就是说可利用SPFA求最短路的入队出队过程判断是否出现负环。


AC code:

#include<iostream>#include<algorithm>#include<cstdio>#include<cstring>#include<queue>#include<vector>#include<map>#include<cmath>#define LL long long#define MAXN 1000010using namespace std;const int INF=0x3f3f3f3f;int n,m,tot,k;int head[MAXN];struct node{int from;int to;int w;int next;}edge[MAXN];int dis[MAXN];bool inq[MAXN];int cnt[MAXN];int path[MAXN];void init(){memset(head,-1,sizeof(head));tot=0;}void add(int from,int to,int w){edge[tot].from=from;edge[tot].to=to;edge[tot].w=w;edge[tot].next=head[from];head[from]=tot++;}bool spfa(int st){deque<int>q;memset(dis,INF,sizeof(dis));memset(inq,false,sizeof(inq));memset(cnt,0,sizeof(cnt));dis[st]=0;q.push_back(st);inq[st]=true;cnt[st]++;while(!q.empty()){int now=q.front();q.pop_front();inq[now]=false;if(cnt[now]>=n){return false;//注意:SPFA求最短路时是对存在负权环有影响,因为会一直入队一直循环下去,}//而存在正权环无影响,因为求最短路是递减的过程,正权环不会一直绕下去,但负权环会,//而利用SPFA求最长路时正好相反。  for(int i=head[now];i!=-1;i=edge[i].next){int nex=edge[i].to;if(dis[nex]>dis[now]+edge[i].w){dis[nex]=dis[now]+edge[i].w;if(!inq[nex]){inq[nex]=true;cnt[nex]++;if(!q.empty()&&dis[nex]<dis[q.front()]){q.push_front(nex);}else{q.push_back(nex);}}}}}return true;//不存在负权环,返回true }int main(){//freopen("D:\in.txt","r",stdin);int T,cas,i,j,u,v,w;scanf("%d",&T);for(cas=1;cas<=T;cas++){scanf("%d%d%d",&n,&m,&k);init();while(m--){scanf("%d%d%d",&u,&v,&w);add(u,v,w);add(v,u,w);}while(k--){scanf("%d%d%d",&u,&v,&w);add(u,v,-w);}if(spfa(1)){printf("NO\n");}else{printf("YES\n"); }  }return 0; } 



0 0